import { VERSION } from './version';
export declare type Pending = 'pending';
export declare class StateSwitch {
    private _name;
    private _on;
    private _pending;
    private log;
    private onPromise;
    private offPromise;
    private onResolver;
    private offResolver;
    constructor(_name?: string, logInstance?: any);
    version(): string;
    setLog(logInstance?: any): void;
    on(): boolean | Pending;
    on(state: true | Pending): void;
    on(state: never): never;
    off(): boolean | Pending;
    off(state: true | Pending): void;
    off(state: never): never;
    ready(state?: 'on' | 'off', noCross?: boolean): Promise<void>;
    /**
     * does the state is not stable(in process)?
     */
    pending(): boolean;
    /**
     * get the client name
     */
    name(): string;
}
export { VERSION, };
export default StateSwitch;
